<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Fasttag;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use App\Exports\ExportFasttag;
use Maatwebsite\Excel\Facades\Excel;
use Auth, DB, Mail, Validator, File, DataTables, Exception;
use App\Imports\ImportFasttag;
class FasttagController extends Controller{
    /** construct */
        public function __construct(){
            $this->middleware('permission:fasttags-create', ['only' => ['create']]);
            $this->middleware('permission:fasttags-edit', ['only' => ['edit']]);
            $this->middleware('permission:fasttags-view', ['only' => ['view']]);
            $this->middleware('permission:fasttags-delete', ['only' => ['delete']]);
        }
    /** construct */
    
    /** index */
        public function index(Request $request){
            if($request->ajax()){
                $data = Fasttag::orderBy('id' , 'desc')->where('status','!=','deleted');
                
                return Datatables::of($data)
                        ->addIndexColumn()
                        ->addColumn('action', function($data){
                            $return = '<div class="btn-group">';

                            if(auth()->user()->can('fasttags-view')){
                                $return .= '<a href="'.route('fasttag.view', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-eye"></i>
                                            </a> &nbsp;';
                            }   
                            
                            if(auth()->user()->can('fasttags-edit')){
                                $return .= '<a href="'.route('fasttag.edit', ['id' => base64_encode($data->id)]).'" class="btn btn-default btn-xs">
                                                <i class="fa fa-pencil"></i>
                                            </a> &nbsp;';
                            }   

                            if (auth()->user()->can('fasttags-delete')) {
                                $return .= '<a href="javascript:;" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
                                                    <i class="fa fa-bars"></i>
                                                </a> &nbsp;
                                                <ul class="dropdown-menu">
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="active" data-id="' . base64_encode($data->id) . '">Active</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="inactive" data-id="' . base64_encode($data->id) . '">Inactive</a></li>
                                                    <li><a class="dropdown-item" href="javascript:;" onclick="change_status(this);" data-status="deleted" data-id="' . base64_encode($data->id) . '">Delete</a></li>
                                                </ul>';
                            }

                            $return .= '</div>';

                            return $return;
                        })

                     
                        ->editColumn('status', function ($data) {
                            if ($data->status == 'active') {
                                return '<span class="badge badge-pill badge-success">Active</span>';
                            } else if ($data->status == 'inactive') {
                                return '<span class="badge badge-pill badge-warning">Inactive</span>';
                            } else if ($data->status == 'deleted') {
                                return '<span class="badge badge-pill badge-danger">Deleted</span>';
                            }else{
                                return '-';
                            }
                        })

                        ->rawColumns([ 'action' ,'status'])
                        ->filter(function ($query) {
                            if (request()->get('brand_name', false)) {
                                $query->where('fasttags.brand_name', 'like', "%" . request()->get("brand_name") . "%");
                            }
                            if (request()->get('amount', false)) {
                                $query->where('fasttags.amount', 'like', "%" . request()->get("amount") . "%"); 
                            }
                            if (request()->get('profit', false)) {
                                $query->where('fasttags.profit', 'like', "%" . request()->get("profit") . "%");
                            }
                            if (request()->get('gst_percentage', false)) {
                                $query->where('fasttags.gst_percentage', 'like', "%" . request()->get("gst_percentage") . "%");
                            }
                            if (request()->get('gst', false)) {
                                $query->where('fasttags.gst', 'like', "%" . request()->get("gst") . "%");
                            }
                            if (request()->get('total_profit', false)) {
                                $query->where('fasttags.total_profit', 'like', "%" . request()->get("total_profit") . "%");
                            }
                        })    
                        ->make(true);
            }
            return view('fasttag.index');
        }
    /** index */
        
    /** create */
        public function create(Request $request){
            return view('fasttag.create');
        }
    /** create */

    /** insert */
        public function insert(Request $request){
            if($request->ajax()){
                return true;
            }
            $crud = [
                'brand_name' => $request->brand_name,
                'amount' => $request->amount,
                'profit' => $request->profit,
                'gst_percentage' => $request->gst_percentage,
                'gst' =>$request->gst,
                'total_profit' =>$request->total_profit,
                'status' => 'active',
                'created_at' => date('Y-m-d H:i:s'),
                'created_by' => auth()->user()->id,
            ];

            DB::beginTransaction();
            try {
                DB::enableQueryLog();
                $last_id = Fasttag::insertGetId($crud);
                if ($last_id) {
                    
                    DB::commit();
                    return redirect()->route('fasttag')->with('success', 'Record inserted successfully');
                } else {
                    DB::rollback();
                    return redirect()->back()->with('error', 'Failed to insert record')->withInput();
                }
            } catch (\Throwable $th) {
                DB::rollback();
                return redirect()->back()->with('error', 'Something went wrong, please try again later')->withInput();
            }
          
        }
    /** insert */

    /** view */
        public function view(Request $request){
            $id = base64_decode($request->id);
            $data = Fasttag::where(['id' => $id])->first();
            return view('fasttag.view')->with(['data' => $data]);
        }
    /** view */

    /** edit */
        public function edit(Request $request){
            $id = base64_decode($request->id);
            $data = Fasttag::where(['id' => $id])->first();
            return view('fasttag.edit')->with(['data' => $data]);
        }
    /** edit */ 

    /** update */
        public function update(Request $request){
            if($request->ajax()){ return true ; }

            $crud = [
                'brand_name' => $request->brand_name,
                'amount' => $request->amount,
                'profit' => $request->profit,
                'gst_percentage' => $request->gst_percentage,
                'gst' =>$request->gst,
                'total_profit' =>$request->total_profit,
                'updated_at' => date('Y-m-d H:i:s'),
                'updated_by' => auth()->user()->id
            ];

            DB::beginTransaction();
            try {
                DB::enableQueryLog();
                $update = Fasttag::where(['id' => $request->id])->update($crud);
                if ($update) {
                    
                    DB::commit();
                    return redirect()->route('fasttag')->with('success', 'Record updated successfully');
                } else {
                    DB::rollback();
                    return redirect()->back()->with('error', 'Failed to update record')->withInput();
                }
            } catch (\Throwable $th) {
                DB::rollback();
                return redirect()->back()->with('error', 'Something went wrong, please try again later')->withInput();
            }
        }
    /** update */

    /** change-status */
        public function change_status(Request $request){
            if (!$request->ajax()) { exit('No direct script access allowed'); }

            $id = base64_decode($request->id);
            $data = Fasttag::where(['id' => $id])->first();

            if (!empty($data)) {
                $update = Fasttag::where(['id' => $id])->update(['status' => $request->status, 'updated_at' => date('Y-m-d H:i:s'), 'updated_by' => auth('sanctum')->user()->id]);
                if ($update) {
                    return response()->json(['code' => 200]);
                } else {
                    return response()->json(['code' => 201]);
                }
            } else {
                return response()->json(['code' => 201]);
            }
           
        }
    /** change-status */

    /** Export */
        public function export(Request $request){
            if(isset($request->slug) && $request->slug != null){
                $slug = $request->slug;
            }else{
                $slug = 'all';
            }

            $name = 'Fasttag_'.Date('YmdHis').'.xlsx';

            try {
                return Excel::download(new ExportFasttag($slug), $name);
            }catch(\Exception $e){
                return redirect()->back()->with('error' ,$e->getMessage());
            }
        }
    /** Export */
    /** Import */
    public function import(Request $request){
           
        if(Excel::import(new ImportFasttag, $request->file('file')->store('file'))){
            return redirect()->route('fasttag')->with('sucess' ,'File Imported Sucessfully');
        }else{
            return redirect()->route('fasttag')->with('error' ,'Faild To Import File!');
        }
    }
/** Import */
}
